<template>
    <v-container class="fill-height" fluid>
        <v-col lg="5" class="mx-auto" md="12" sm="12">
            <v-card outlined class="pa-3 mx-auto" :elevation="4">
                <v-card-text>
                    <v-alert v-if="err != ''" dense text type="error">
                        {{err}}
                    </v-alert>
                    <v-alert v-if="ok != ''" dense text type="success">
                        {{success}}
                    </v-alert>
                    <p class="display-1 text--primary">
                        Create SubContractor
                    </p>

                    <v-form ref='form' v-model="valid">
                        <v-row>
                            <v-text-field label="SubContractor Name"
                                          name="SubContractor Name"
                                          :counter="64"
                                          v-model="name"
                                          :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.subcontractor' :''"
                                          :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.subcontractor' : ''"
                                          required
                                          :rules="rules"
                                          type="text"/>
                            <v-spacer/>
                            <v-dialog v-model="imageDialog" persistent max-width="600px">
                                <template #activator="{ on , attrs }">
                                    <v-btn fab v-bind="attrs" v-on="on">
                                        <v-avatar>
                                            <v-icon v-if="logo == ''">
                                                $vuetify.icons.camera
                                            </v-icon>
                                            <img v-else :src="logo" alt="company logo"/>
                                        </v-avatar>
                                    </v-btn>
                                </template>
                                <ImageLoader
                                        title="Choose Company Logo"
                                        :on-select="ChooseImage"
                                />
                            </v-dialog>

                        </v-row>
                        <v-row>
                            <v-text-field label="Color"
                                          name="Color"
                                          v-model="color"

                                          :prepend-icon="!$vuetify.breakpoint.mobile ?'$vuetify.icons.color' :''"
                                          :prepend-inner-icon="$vuetify.breakpoint.mobile ? '$vuetify.icons.color' : ''"
                                          :rules="required"
                                          required
                                          type="text"/>
                            <v-spacer/>
                            <v-menu offset-x>
                                <template #activator="{ on , attrs }">
                                    <v-btn fab :color="color" v-bind="attrs" v-on="on"/>
                                </template>
                                <v-color-picker v-model="color" elevation="15"/>
                            </v-menu>

                        </v-row>
                    </v-form>
                </v-card-text>

                <v-card-actions>
                    <v-btn color="primary" to="/sub">
                        Back
                    </v-btn>
                    <v-spacer/>
                    <v-btn color="primary" :disabled="!valid" @click="Create">
                        Create
                    </v-btn>
                </v-card-actions>
            </v-card>
        </v-col>
    </v-container>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component} from 'vue-property-decorator';
    import {Mixins} from "vue-mixin-decorator";
    import {Validable} from "../../mixins/Validable";
    import ImageLoader from "../../components/ImageLoader.vue";
    import ColorLoader from "../../components/ColorLoader.vue";
    import {coreApi} from "../../init";
    import {SubContractorResponse} from "../../../../classLibrary/core/subContractorResponse";

    @Component({
        components: {ColorLoader, ImageLoader}
    })
    export default class CreateSubContractor extends Mixins<Validable>(Validable) {
        name: string = '';
        logo: string = '';
        color: string = ['blue', 'green', 'yellow', 'red', 'orange', 'purple'].Random()!;
        imageDialog: boolean = false;

        valid: boolean = true;

        required = [
            (v: any) => !!v || 'Required',
        ]

        rules = [
            (v: any) => !!v || 'SubContractor Name is required',
            (v: any) => (v && v.length >= 5) || 'SubContractor  must be at least 5 characters long',
            (v: any) => (v && v.length <= 16) || 'SubContractor  cannot exceed 64 characters long',
        ]


        async Create() {
            if (this.valid) {
                if (this.logo != '') {
                    const r = await coreApi.Post<SubContractorResponse>("SubContractor", {
                        name: this.name,
                        logo: this.logo,
                        color: this.color,
                        data: {},
                    });
                    if (r.success) {
                        this.ok = "Successfully created Subcontractor!";
                        await this.$router.push(`/sub/${r.Ok!.light.id}`);
                    } else {
                        this.err = r.error!;
                    }
                } else {
                    this.err = "Please choose a company logo!"
                }
            }
        }

        ChooseImage(s: string) {
            this.logo = s;
            this.imageDialog = false;
        }
    }
</script>
